//
//  ViewController.m
//  CatRaceStarter
//
//  Created by Kauserali on 30/12/13.
//  Copyright (c) 2013 Raywenderlich. All rights reserved.
//

#import "GameViewController.h"
#import "GameOverViewController.h"
#import "GameScene.h"
#import "GameKitHelper.h"

@interface GameViewController()<GameKitHelperDelegate>

@end

@implementation GameViewController

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(playerAuthenticated)
                                                 name:LocalPlayerIsAuthenticated object:nil];
}

- (void)playerAuthenticated {
    [[GameKitHelper sharedGameKitHelper] findMatchWithMinPlayers:2 maxPlayers:2 viewController:self delegate:self];
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)viewWillLayoutSubviews {
    [super viewWillLayoutSubviews];

    // Configure the view.
    SKView * skView = (SKView *)self.view;
    skView.showsFPS = YES;
    skView.showsNodeCount = YES;
    
    // Create and configure the scene.
    GameScene * scene = [GameScene sceneWithSize:skView.bounds.size];
    scene.scaleMode = SKSceneScaleModeAspectFill;
    
    scene.gameEndedBlock = ^() {

    };
    
    scene.gameOverBlock = ^(BOOL didWin) {
        GameOverViewController *gameOverViewController = (GameOverViewController*)[self.storyboard instantiateViewControllerWithIdentifier:@"GameOverViewController"];
        gameOverViewController.didWin = didWin;
        [self.navigationController pushViewController:gameOverViewController animated:YES];
    };
    // Present the scene.
    [skView presentScene:scene];
}

// Add new methods to bottom of file
#pragma mark GameKitHelperDelegate

- (void)matchStarted {
    NSLog(@"Match started");
}

- (void)matchEnded {
    NSLog(@"Match ended");
}

- (void)match:(GKMatch *)match didReceiveData:(NSData *)data fromPlayer:(NSString *)playerID {
    NSLog(@"Received data");
}

@end
